//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "AddrsDlg.h"
#include "FileMan.h"
#include "Global.h"

const AnsiString General = "General";
const AnsiString Newsgroups = "Newsgroups";
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAddressDlg *AddressDlg;
//---------------------------------------------------------------------------
bool __fastcall GetMailRecipients(TStrings *Addresses, TStrings *Newsgroups, int Mode)
{
   int i;
   AnsiString s;
   Addresses->Clear();
   Newsgroups->Clear();
   TAddressDlg *ad = new TAddressDlg(Application->MainForm);
   ad->SetMode(Mode);
   ad->ShowModal();
   if (ad->ModalResult==mrOk)
   {
      // addresses
      for (i=0; i<ad->AddrsList->Items->Count; i++)
         if (ad->AddrsList->Selected[i])
            Addresses->Add(ad->AddrsList->Items->Strings[i]);
      for (i=0; i<Addresses->Count; i++)
      {
         s = Addresses->Strings[i];
         if (i>0) s = " " + s;
         if (i<Addresses->Count-1) s += ",";
         Addresses->Strings[i] = s;
      }
      if (Addresses->Count)
      {
         s = Addresses->Strings[0];
         if (ad->BccBtn->Checked) Addresses->Strings[0] = "Bcc: "+s; else
         if (ad->CcBtn->Checked) Addresses->Strings[0] = "Cc: "+s; else
         if (ad->ToBtn->Checked) Addresses->Strings[0] = "To: "+s;
      }
      // newsgroups
      for (i=0; i<ad->GrpsList->Items->Count; i++)
         if (ad->GrpsList->Selected[i])
            Newsgroups->Add(ad->GrpsList->Items->Strings[i]);
      for (i=0; i<Newsgroups->Count; i++)
      {
         s = Newsgroups->Strings[i];
         if (i>0) s = " " + s;
         if (i<Newsgroups->Count-1) s += ",";
         Newsgroups->Strings[i] = s;
      }
      if (Newsgroups->Count)
      {
         s = Newsgroups->Strings[0];
         if (ad->GroupsBtn->Checked) Newsgroups->Strings[0] = "Newsgroups: "+s; else
         if (ad->FollowBtn->Checked) Newsgroups->Strings[0] = "Followup-To: "+s;
      }
   }
   delete ad;
   return Addresses->Count>0 || Newsgroups->Count>0;
}
//---------------------------------------------------------------------------
__fastcall TAddressDlg::TAddressDlg(TComponent* Owner)
	: TForm(Owner)
{
   // Center in Main Window
   TForm *Main = Application->MainForm;
   Top = Main->Top+((Main->Height-Height)/2);
   Left = Main->Left+((Main->Width-Width)/2);
   // initialize Address list
   GetAppData(AddrsList->Items,UserAddresses+PS+General);
   AddrsEditor->Align = alClient;
   // initialize Newsgroups list
   GetAppData(GrpsList->Items,UserAddresses+PS+Newsgroups);
   GrpsEditor->Align = alClient;
   // init
   orglistwidth = Panel3->Width;
   PageControl1->ActivePage = TabSheet1;
   mode = modeNone;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::SetMode(int newMode)
{
   if (newMode==modeAddress)
   {
      bool locked=LockWindowUpdate(Handle);
      if (mode==modeEdit)
      {
         OkBtn->Caption = "Ok";
         AddrsList->Sorted = true;
         AddrsList->Items->Text = AddrsEditor->Lines->Text;
         PutAppData(UserAddresses+PS+General,AddrsList->Items);
         AddrsList->Sorted = false;

         OkBtn->Caption = "Ok";
         GrpsList->Sorted = true;
         GrpsList->Items->Text = GrpsEditor->Lines->Text;
         PutAppData(UserAddresses+PS+Newsgroups,GrpsList->Items);
         GrpsList->Sorted = false;
      }
      GrpsList->Visible = true;
      Panel1->Align = alLeft;
      Panel1->Width = orglistwidth;
      Panel3->Align = alLeft;
      Panel3->Width = orglistwidth;
      Label1->Visible = true;
      for (int i=0; i<AddrsList->Items->Count; i++)
         AddrsList->Selected[i] = false;
      for (int i=0; i<GrpsList->Items->Count; i++)
         GrpsList->Selected[i] = false;
      if (locked) LockWindowUpdate(0);
   }
   else
   if (newMode==modeEdit)
   {
      bool locked=LockWindowUpdate(Handle);

      AddrsEditor->Lines->Text = AddrsList->Items->Text;
      AddrsEditor->Modified = false;
      AddrsList->Visible = false;
      AddrsEditor->SelStart = 0;
      Panel3->Align = alClient;

      GrpsEditor->Lines->Text = GrpsList->Items->Text;
      GrpsEditor->Modified = false;
      GrpsList->Visible = false;
      GrpsEditor->SelStart = 0;
      Panel1->Align = alClient;

      ActiveControl = PageControl1->ActivePage==TabSheet1 ? AddrsEditor:GrpsEditor;
      Label1->Visible = false;
      OkBtn->Caption = "Done";
      if (locked) LockWindowUpdate(0);
   }
   else
   if (newMode==modeNoAddress)
   {
      bool locked=LockWindowUpdate(Handle);
      AddrsEditor->Lines->Text = AddrsList->Items->Text;
      AddrsEditor->Modified = false;
      AddrsList->Visible = false;
      AddrsEditor->SelStart = 0;
      Panel3->Align = alClient;

      GrpsEditor->Lines->Text = GrpsList->Items->Text;
      GrpsEditor->Modified = false;
      GrpsList->Visible = false;
      GrpsEditor->SelStart = 0;
      Panel1->Align = alClient;

      ActiveControl = PageControl1->ActivePage==TabSheet1 ? AddrsEditor:GrpsEditor;
      Label1->Visible = false;
      OkBtn->Caption = "Ok";
      if (locked) LockWindowUpdate(0);
   }
   mode = newMode;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::EditAddrBtnClick(TObject *Sender)
{
   SetMode(modeEdit);
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::OkBtnClick(TObject *Sender)
{
   if (OkBtn->Caption=="Done")
   {
      SetMode(modeAddress);
      return;
   }
   if (mode==modeNoAddress)
   {
      if (AddrsEditor->Modified)
         PutAppData(UserAddresses+PS+General,AddrsEditor->Lines);
      if (GrpsEditor->Modified)
         PutAppData(UserAddresses+PS+Newsgroups,GrpsEditor->Lines);
   }
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::AddrsListDblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::CancelBtnClick(TObject *Sender)
{
   if (OkBtn->Caption=="Done" || mode==modeNoAddress)
   {
      if (AddrsEditor->Modified || GrpsEditor->Modified)
      {
         if (MsgBoxHwnd(Handle,
         "Your book is modified!\n\nAre you sure you want to cancel?",
         "Addresses, etc",MB_YESNO)==IDNO)
              return;
      }
      if (mode != modeNoAddress)
      {
         SetMode(modeAddress);
         return;
      }
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
