//---------------------------------------------------------------------------
#ifndef MsgWinH
#define MsgWinH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include "NoteWin.h"
#include "HeadMan.h"
#include "Global.h"
#include "FileMan.h"
//#include "PopButton.hpp"
#include "explbtn.hpp"
//---------------------------------------------------------------------------
bool __fastcall OpenMessage(AnsiString &MailBox, AnsiString &IndexStr);
bool __fastcall SetMsgStatus(AnsiString &DataKey, char status);
char __fastcall GetMsgStatus(AnsiString &DataKey);
bool __fastcall IsNewStyle(AnsiString &DataKey);
bool __fastcall IsIncoming(AnsiString &IndexStr);
bool __fastcall CutMessageAtCutmarks(TStrings *msg);
const AnsiString newMessage = AnsiString("New Message");
const AnsiString newArticle = AnsiString("New Usenet Article");
const AnsiString DefaultMessage = "default"+PS+"message";
const AnsiString DefaultArticle = "default"+PS+"article";
const AnsiString EncryptTo = "Encrypt-To: ";
const bool Limit80Chars = true;

class TMessageWin : public TTextWin
{
__published:	// IDE-managed Components
  TTimer *Timer1;
  TMenuItem *N7;
  TMenuItem *PopDoPgpItem;
  TPopupMenu *PopupSaveMenu;
  TMenuItem *PopupSaveItem;
  TMenuItem *PopupSaveasItem;
  TMenuItem *PopupSaveasTemplateItem;
  TMenuItem *PopupSaveasDefItem;
  TMenuItem *PopupSaveDefMessageItem;
  TMenuItem *PopupSaveDefArticleItem;
  TMenuItem *N8;
  TMenuItem *PopupTransferItem;
  TMenuItem *PopupDeleteItem;
  TMenuItem *PopupCopyMessageItem;
  TMenuItem *N9;
  TTimer *Timer2;
  TMenuItem *PopFinalFormatItem;
  TOfficeButton *QueueBtn;
  TOfficeButton *PGPencBtn;
  TOfficeButton *PGPsigBtn;
  TBevel *Bevel2;
  TOfficeButton *SaveBtn;
  TBevel *Bevel4;
  TMenuItem *SaveasNote1;
  TBevel *Bevel10;
  TOfficeButton *AddrsBtn;
  TBevel *Bevel3;
  TOfficeButton *MsgHelpBtn;
  void __fastcall QueueBtnClick(TObject *Sender);
  void __fastcall OkBtnClick(TObject *Sender);
  void __fastcall PGPencBtnClick(TObject *Sender);
  void __fastcall PGPsigBtnClick(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall PopupMenuClick(TObject *Sender);
  void __fastcall PopDoPgpItemClick(TObject *Sender);
  void __fastcall SaveBtnClick(TObject *Sender);
  void __fastcall PopupSaveMenuPopup(TObject *Sender);
  void __fastcall PopupSaveItemClick(TObject *Sender);
  void __fastcall PopupQueueMessageClick(TObject *Sender);
  void __fastcall PopupSaveasItemClick(TObject *Sender);
  void __fastcall PopupSaveasTemplateItemClick(TObject *Sender);
  void __fastcall PopupSaveDefMessageItemClick(TObject *Sender);
  void __fastcall PopupSaveDefArticleItemClick(TObject *Sender);
  void __fastcall PopupTransferItemClick(TObject *Sender);
  void __fastcall PopupDeleteItemClick(TObject *Sender);
  void __fastcall PopupCopyMessageItemClick(TObject *Sender);
  void __fastcall Timer2Timer(TObject *Sender);
  void __fastcall SaveMessageBtnClick(TObject *Sender);
  void __fastcall EditorSelectionChange(TObject *Sender);
  void __fastcall PopFinalFormatItemClick(TObject *Sender);
  void __fastcall OkBtnEnter(TObject *Sender);
  void __fastcall OkBtnExit(TObject *Sender);
  void __fastcall SaveBtnEnter(TObject *Sender);
  void __fastcall SaveBtnExit(TObject *Sender);
  
  void __fastcall AddrsBtnClick(TObject *Sender);
  void __fastcall MsgHelpBtnClick(TObject *Sender);
  
private: // User declarations
public:	 // User declarations
   bool MessageSent;
   bool FinalFormat;
   THeaderManager *Headers;
   AnsiString PGPsecringPath;
   AnsiString PGPpubringPath;
   AnsiString Mailbox,InReplyTo;
   virtual __fastcall TMessageWin(TComponent* Owner);
   virtual __fastcall TMessageWin(TStrings* Message, AnsiString &mailbox,
      AnsiString &indexstr, TComponent *Owner);
   virtual __fastcall ~TMessageWin();
   AnsiString __fastcall Name();
   AnsiString __fastcall Section();
   void __fastcall SetMessage(bool setcursor=true);
   bool __fastcall UpdateStatsOnSend();
   void __fastcall RegisterStatsUpdated();
   bool __fastcall SaveAsTemplate();
   void __fastcall SaveDefMessage();
   void __fastcall SaveDefArticle();
   bool __fastcall CheckProblemsQueue();
   bool __fastcall CheckMailQueue();
   bool __fastcall CheckNewsgroups();
   void __fastcall CheckReferences();
   bool __fastcall CheckOver80Chars();
   virtual bool __fastcall CheckSave();
   virtual bool __fastcall SaveAs(); // SaveMessage
   virtual bool __fastcall Save();
   void __fastcall NewMessage();
   void __fastcall NewArticle();
   bool __fastcall CheckValid();
   bool __fastcall ValidMail();
   void __fastcall SetCursor();
   void __fastcall CheckWhiteEOH(); // corrects for empty line that is actually white-space
   bool __fastcall Queue(bool UseDialog=true);
   bool __fastcall Send();
   int  __fastcall SendWordWrap();
   // not used currently =====
   void __fastcall LoadMessage(AnsiString &Mailname); // handles pgphdrtobtns
   void __fastcall SaveMessage(AnsiString &Mailname); // handles btnstopgphdr
   //=========================
   void __fastcall TransferMessageTo(AnsiString &Boxname);
   void __fastcall CopyMessageTo(AnsiString &Boxname);
   void __fastcall SetNoPgp();
   // pgp
   bool __fastcall ButtonsToPgpHeader(TStrings *Message);
   bool __fastcall PgpHeaderToButtons(TStrings *Message);
   bool __fastcall CEncryptMessage();
   void __fastcall SetNoMixmaster();
   bool __fastcall HandleCPGP();
   bool __fastcall HandlePGP();
};
//---------------------------------------------------------------------------
extern TMessageWin *MessageWin;
//---------------------------------------------------------------------------
#endif
